﻿using FishFactoryContracts.DI;
using FishFactoryContracts.StoragesContracts;
using FishFactoryFileImplement.Implements;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FishFactoryFileImplement
{
	public class FileImplementationExtension : IImplementationExtension
	{
		public int Priority => 1;

		public void RegisterServices()
		{
			DependencyManager.Instance.RegisterType<IClientStorage, ClientStorage>();
			DependencyManager.Instance.RegisterType<IComponentStorage, ComponentStorage>();
			DependencyManager.Instance.RegisterType<IImplementerStorage, ImplementerStorage>();
			DependencyManager.Instance.RegisterType<IMessageInfoStorage, MessageInfoStorage>();
			DependencyManager.Instance.RegisterType<IOrderStorage, OrderStorage>();
			DependencyManager.Instance.RegisterType<ICannedStorage, CannedStorage>();
			DependencyManager.Instance.RegisterType<IBackUpInfo, BackUpInfo>();
		}
	}
}
